Module DomainSplitting.
(* ------------------------------------------------
     Domain splitting
   ------------------------------------------------ *)

Lemma forall_domain2 : forall {A}(P X Y : A -> Prop),
  (forall a : A, P a -> X a /\ Y a) <->
  (forall a : A, P a -> X a) /\ (forall a : A, P a -> Y a).
Proof.
intros ; intuition ; specialize H with a ; intuition.
Qed.

Lemma forall_domain3 : forall {A}(P X Y Z : A -> Prop),
  (forall a : A, P a -> X a /\ Y a /\ Z a) <->
  (forall a : A, P a -> X a) /\ (forall a : A, P a -> Y a) /\ (forall a : A, P a -> Z a).
Proof.
intros ; intuition ; specialize H with a ; intuition.
Qed.

Lemma exists_forall_domain2 : forall {A}{B}(P X Y : A -> B -> Prop),
  (exists b, forall a, P a b -> X a b /\ Y a b) <->
  (exists b, (forall a, P a b -> X a b) /\ (forall a, P a b -> Y a b)).
Proof.
intuition ; destruct H as [b H] ; exists b ;
apply forall_domain2 ; exact H.
Qed.

Lemma exists_forall_domain3 : forall {A}{B}(P X Y Z : A -> B -> Prop),
  (exists b, forall a, P a b -> X a b /\ Y a b /\ Z a b) <->
  (exists b, (forall a, P a b -> X a b) /\ (forall a, P a b -> Y a b) 
             /\ (forall a, P a b -> Z a b)).
Proof.
intuition ; destruct H as [b H] ; exists b ;
apply forall_domain3 ; exact H.
Qed.

End DomainSplitting.