Module OptionProps.
(* ------------------------------------------------
     Option Lemmas
   ------------------------------------------------ *)

Lemma OptionSomeEq {A} : forall (a1 a2 : A), Some a1 = Some a2 <-> a1 = a2.
intuition.
inversion H.
auto.
congruence.
Qed.

Lemma OptionSomeNeq {A} : forall (a1 a2 : A), Some a1 <> Some a2 <-> a1 <> a2.
intuition ; apply H.
congruence.
inversion H0.
auto.
Qed.

Lemma OptionSum : forall {A} (a : option A), {x : A | a = Some x} + {a = None}.
Proof.
simple induction a.
left.
split with a0.
reflexivity.
right.
reflexivity.
Qed.

End OptionProps.